/*		okepl: osszegkeplet feldolgozasa
   Kulonfele alakokrol eloszor H2SO4 alakra, aztan |H=2|S=1|O=4 alakra hozzuk.
   Az elobbi azert jo, mert a kulonfele alakok konnyen atalakithatok ra. Lehetnek benne ismetlodo vegyjelek es ()-ek.
*/

#include <string.h>
#include <libgyim.h>
#include "osszeg.h"

int okepl(const char *keplet,int rendflg,char *eredm,int eredhossz)
{
char *txt = memker(NULL,strlen(keplet)+1);		// nem rontjuk el az eredetit
int ret,hossz;
struct keplstr kepl;
#define	FMT	"%-25s"
#define	SZAM	"%-5d"

strcpy(txt,keplet);
#ifdef	DEBUG
fprintf(stderr,FMT"%s\n","Eredeti sor:",txt);
#endif

tisztit(txt);	// <ref -ek es html kommentek torlese
#ifdef	DEBUG
fprintf(stderr,FMT"%s\n","Tisztitas utan:",txt);
#endif

ret = okepl1(txt);		// C6H5NH(COCH3) alak
#ifdef	DEBUG
fprintf(stderr,FMT"ret="SZAM"%s\n","Elso fazis",ret,txt);
#endif
if(ret)	goto kilep;

ret = okepl2(txt,&kepl);	// eredm feltoltese
#ifdef	DEBUG
fprintf(stderr,FMT"ret="SZAM"\n","Masodik fazis",ret);
#endif
if(ret)	goto kilep;

hossz = keplkihossz(&kepl);
ret = hossz < eredhossz? 0: 30;
#ifdef	DEBUG
fprintf(stderr,FMT"ret="SZAM"kell: %d, van: %d\n","Eredmenypuffer hossza",ret,hossz,eredhossz);
#endif
if(ret)	goto kilep;	// ret = 0, mar nem valtozik

if(rendflg)
	{
#ifdef	DEBUG
	okeplki(eredm,&kepl);
	fprintf(stderr,FMT"%s\n","Rendezes elott",eredm);
#endif
	keplrend(&kepl);
	}

okeplki(eredm,&kepl);
#ifdef	DEBUG
	fprintf(stderr,FMT"%s\n","Vegeredmeny",eredm);
#endif

kilep:
free(txt);
return ret;
}

#ifdef	MAIN

int main(int argc,char *argv[])
{
char tomb[100];
int ret;

if(argc < 2)
	{
	puts("Hivas: okepltst keplet\nPl.: okepltst 'H<sub>2</sub>O'");
	return(1);
	}
ret = okepl(argv[1],1,tomb,sizeof(tomb));
fprintf(stderr,FMT"%d\n","Visszateresi ertek:",ret);
if(ret == 0)
	puts(tomb);
return ret;
}

void sablfv() {}

#endif

