#include <string.h>
#include <libgyim.h>
#include "osszeg.h"

void tisztit(char *str)
{	// torli a stringbol a html kommenteket es a <ref>-eket
static const char *kezdo[] = { "<ref", "<!--" }, *veg[] = { "</ref>", "-->" },
	refveg[] = "/>";	// lehet ilyen is: <ref .../>
struct tobbszovstr eredm;
char *mut,*ref;
int hossz,szam;

while( (szam = tobbszov(str,sizeof(kezdo)/sizeof(char *),kezdo,&eredm)) >= 0)
	{
	mut = strstr(eredm.kcim,veg[eredm.srsz]); 		// mut a lezaro tag str-ben
	hossz = strlen(veg[eredm.srsz]);			// a lezaro tag hossza
	if(szam == 0)
		ref = strstr(eredm.kcim,refveg);
	else	ref = NULL;
	if(ref != NULL && (mut == NULL || ref < mut) )
		{
		mut = ref;	// /> elobb jott, mint </ref>
		hossz = strlen(refveg);
		}
	if( mut != NULL)	// mut a lezaro tag
		memmove(eredm.kcim,mut+hossz,strlen(mut)+1);
	else	break;	// nincs parja a nyito tag-nak. Kilepunk, kulonben vegtelen ciklusba esnenk.
	}
vegvag(str," \n");
}

void tisztit2(char *str)
{	// a fentin kivul torli a stringbol a \n-eket es <br />-eket
char *mut;

tisztit(str);
for(mut=str; (mut = strstr(mut,"<br")) != NULL; )
	{
	char *m = mut + 3;	// 3 = strlen("<br");

	m += strspn(m," ");
	if(*m == '/')
		m++;
	if(*m++ == '>')
		memmove(mut,m,strlen(m)+1);
	}
for(mut=str; (mut = strchr(mut,'\n')) != NULL; mut++)
	*mut = ' ';	// a \n-eket helykozre valtoztatjuk
}


void tisztithash(char *str)	// torli a #-eket
{
char *mut = str;
int szam;

while( (mut=strstr(mut,"&#")) != NULL)
	{
	char *oldmut = mut;	// az & jelen all

	mut += 2;
	if(sscanf(mut,"%d",&szam) > 0)
		{
		mut += strspn(mut,"0123456789");
		if(*mut++ == ';')
			{
			*oldmut++ = szam;
			memmove(oldmut,mut,strlen(mut)+1);
			}
		}
	}
while( (str = strchr(str,'#')) != NULL)
	*str = ' ';
}


#ifdef	MAIN

int  main(int argc, char *argv[])
{
static const char *tomb[] = { //"Eleje, <!--A kozepen komment-->yyy<ref>Utana ref</ref> es meg tovabb",
		//"Tetrakis(dimethylamino)titanium<br />\n(IV)",
		"Reinecke&#39;s#salt"
 };
char sor[120];
#define	SORHOSSZ	sizeof(sor)
int i;

if(argc < 2)
	{
	for(i=0; i < sizeof(tomb)/sizeof(char *); i++)
		{
		strcpy(sor,tomb[i]);
		printf("\nEredeti sor:      %s\n",sor);
		tisztit2(sor);
		  printf("tisztit2    utan: %s\n",sor);
		tisztithash(sor);
		  printf("tisztithash utan: %s\n",sor);
		}
	}
else	{
	strncpy(sor,argv[1],SORHOSSZ);
	sor[SORHOSSZ-1] = 0;
	printf("%zd %s\n",strlen(sor),sor);
	tisztit2(sor);
	printf("%s\n",sor);
	}
return 0;
}

#endif
